@echo off
rem
rem Converting doml 5.* file into doml 8 file.
rem 
rem  doml2doml8 [-help] [doml5*-file] [doml8-file] 
rem
rem  -help - Print usage message and exit.
rem
rem  doml5*-file - doml file relese 5.*.
rem  doml8-file - desired target doml file
rem


set USAGE=doml2doml8 [-help] [doml5*-file] [doml8-file]

set DODS_HOME=d:\sasaboy\prozonecvs\DODSX\output

set PATH="C:/jdk1.5.0_14\bin";%PATH%
set JAVACMD=java.exe

set DOML2DOML8XSL="%DODS_HOME%\build\xsl\doml2doml8.xsl"

:start0
if exist %DOML2DOML8XSL% goto start
echo.
echo Unable to find necessary xsl file. Set DOML2DOML8XSL in this bat file.
echo.
goto exit

:start
if %1.==. goto error1
if %1==-help goto help
if %1==-* goto error2
if %1==* goto continue1
goto continue1

:error1
echo Error: There is not any arguments: %USAGE%
goto exit

:error2
echo Error: Invalid option: %USAGE%
goto exit

:error3
echo Error: There is not second argument: %USAGE%
goto exit

:error4
echo Error: There are more then two arguments: %USAGE%
goto exit

:help
echo.
echo Usage: %USAGE%
echo.
goto exit

:continue1
if %2.==. goto error3
if %2==-* goto error2
if %2==* goto continue2
goto continue2

:continue2
if %3.==. goto continue
goto error4


:continue
echo
echo Doml to Doml version 8 conversion...

%JAVACMD% -cp "%CLASSPATH%" org.apache.xalan.xslt.Process -in %1 -xsl %DOML2DOML8XSL% -out %2
:exit