@echo off
rem
rem Converting doml 5.* file into pdf file.
rem
rem  doml2pdf [-help] [doml5*-file] [pdf-file] 
rem
rem  -help - Print usage message and exit.
rem
rem doml5*-file - doml file relese 5.*.
rem pdf-file - desired target pdf file
rem


set USAGE=doml2pdf [-help] [doml5*-file] [pdf-file]


set DODS_HOME=d:\sasaboy\prozonecvs\DODSX\output

:start
if %1.==. goto error1
if %1==-help goto help
if %1==-* goto error2
if %1==* goto continue1
goto continue1

:error1
echo Error: There is not any arguments: %USAGE%
goto exit

:error2
echo Error: Invalid option: %USAGE%
goto exit

:error3
echo Error: There is not second argument: %USAGE%
goto exit

:error4
echo Error: There are more then two arguments: %USAGE%
goto exit

:help
echo.
echo Usage: %USAGE%
echo.
goto exit

:continue1
if %2.==. goto error3
if %2==-* goto error2
if %2==* goto continue2
goto continue2

:continue2
if %3.==. goto continue
goto error4


:continue
echo Doml to pdf conversion...
call "%DODS_HOME%\bin\doml2fo.bat" %1 %1.fo
call "%DODS_HOME%\bin\fo2pdf.bat" %1.fo %2 2>%2.log
del %1.fo

:exit