package allinone;

import com.lutris.appserver.server.sql.*;
import com.lutris.util.*;
import org.enhydra.dods.*;
import java.sql.SQLException;


import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;
import com.lutris.appserver.server.sql.*;
import allinone.data.tableA.*;
import allinone.data.tableB.*;
import allinone.data.tableC.*;
import allinone.data.tableD.*;

public class MultiReference{
    void showTables(DBTransaction dbTrans){
        try{
            NDCTableAQuery queryA = new NDCTableAQuery(dbTrans);
            NDCTableADO[] allADO = queryA.getDOArray();
            System.err.println();
            System.err.println("-------------TableA-----begin----------");
            if(allADO!=null) {
                if(allADO.length>0)System.err.println("---oid------someData------refToC---refToD-----");
                for(int i=0; i<allADO.length; i++){
                    System.err.print("   "+allADO[i].getHandle());
                    System.err.print("   "+allADO[i].getSomedata());
                    System.err.print("   "+(null != allADO[i].getReftoc()?allADO[i].getReftoc().getHandle():"null"));
                    System.err.print("   "+(null != allADO[i].getReftob()?allADO[i].getReftob().getHandle():"null"));
                    System.err.println();
                }
            } else {
                System.err.println("noData");
            }
            System.err.println("-------------TableA-----end------------");

            NDCTableBQuery queryB = new NDCTableBQuery(dbTrans);
            NDCTableBDO[] allBDO = queryB.getDOArray();
            System.err.println();
            System.err.println("-------------TableB-----begin----------");
            if(allBDO!=null) {
                if(allBDO.length>0)System.err.println("---oid------someData------refToD-----");
                for(int i=0; i<allBDO.length; i++){
                    System.err.print("   "+allBDO[i].getHandle());
                    System.err.print("   "+allBDO[i].getSomedata());
                    System.err.print("   "+(null != allBDO[i].getReftod()?allBDO[i].getReftod().getHandle():"null"));
                    System.err.println();
                }
            } else {
                System.err.println("noData");
            }
            System.err.println("-------------TableB-----end------------");

            NDCTableCQuery queryC = new NDCTableCQuery(dbTrans);
            NDCTableCDO[] allCDO = queryC.getDOArray();
            System.err.println();
            System.err.println("-------------TableC-----begin----------");
            if(allCDO!=null) {
                if(allCDO.length>0)System.err.println("---oid------someData------refToD-----");
                for(int i=0; i<allCDO.length; i++){
                    System.err.print("   "+allCDO[i].getHandle());
                    System.err.print("   "+allCDO[i].getSomedata());
                    System.err.print("   "+(null != allCDO[i].getReftod()?allCDO[i].getReftod().getHandle():"null"));
                    System.err.println();
                }
            } else {
                System.err.println("noData");
            }
            System.err.println("-------------TableC-----end------------");

            NDCTableDQuery queryD = new NDCTableDQuery(dbTrans);
            NDCTableDDO[] allDDO = queryD.getDOArray();
            System.err.println();
            System.err.println("-------------TableD-----begin----------");
            if(allDDO!=null) {
                if(allDDO.length>0)System.err.println("---oid------someData--------");
                for(int i=0; i<allDDO.length; i++){
                    System.err.print("   "+allDDO[i].getHandle());
                    System.err.print("   "+allDDO[i].getSomedata());
                    System.err.println();
                }
            } else {
                System.err.println("noData");
            }
            System.err.println("-------------TableD-----end------------");
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    public void runTest(DBTransaction dbTrans1) {
        try {
            boolean autoWrite = ((StandardDatabaseManager)DODS.getDatabaseManager()).getDatabaseManagerConfiguration().getAutoWrite();
            System.err.println("___ - + * startin MultRef with unDelete * + -  ___");
            showTables(dbTrans1);

            NDCTableDDO tableD1 = NDCTableDDO.createVirgin(dbTrans1);
            tableD1.setSomedata("tableD1");
            tableD1.save();
            NDCTableDDO tableD2 = NDCTableDDO.createVirgin(dbTrans1);
            tableD2.setSomedata("tableD2");
            tableD2.save();
            NDCTableDDO tableD3 = NDCTableDDO.createVirgin(dbTrans1);
            tableD3.setSomedata("tableD3");
            tableD3.save();
            NDCTableDDO tableD4 = NDCTableDDO.createVirgin(dbTrans1);
            tableD4.setSomedata("tableD4");
            tableD4.save();
            NDCTableDDO tableD5 = NDCTableDDO.createVirgin(dbTrans1);
            tableD5.setSomedata("tableD5");
            tableD5.save();
            NDCTableDDO tableD6 = NDCTableDDO.createVirgin(dbTrans1);
            tableD6.setSomedata("tableD6");
            tableD6.save();
            if(!autoWrite)
                dbTrans1.write();

            NDCTableCDO tableC1 = NDCTableCDO.createVirgin(dbTrans1);
            tableC1.setSomedata("tableC1");
            tableC1.setReftod(tableD1);
            tableC1.save();
            NDCTableCDO tableC2 = NDCTableCDO.createVirgin(dbTrans1);
            tableC2.setSomedata("tableC2");
            tableC2.setReftod(tableD2);
            tableC2.save();
            NDCTableCDO tableC3 = NDCTableCDO.createVirgin(dbTrans1);
            tableC3.setSomedata("tableC3");
            tableC3.setReftod(tableD3);
            tableC3.save();
            NDCTableCDO tableC4 = NDCTableCDO.createVirgin(dbTrans1);
            tableC4.setSomedata("tableC4");
            tableC4.setReftod(tableD4);
            tableC4.save();
            NDCTableCDO tableC5 = NDCTableCDO.createVirgin(dbTrans1);
            tableC5.setSomedata("tableC5");
            tableC5.setReftod(tableD5);
            tableC5.save();
            NDCTableCDO tableC6 = NDCTableCDO.createVirgin(dbTrans1);
            tableC6.setSomedata("tableC6");
            tableC6.setReftod(tableD6);
            tableC6.save();
            if(!autoWrite)
                dbTrans1.write();

            NDCTableBDO tableB1 = NDCTableBDO.createVirgin(dbTrans1);
            tableB1.setSomedata("tableB1");
            tableB1.setReftod(tableD1);
            tableB1.save();
            NDCTableBDO tableB2 = NDCTableBDO.createVirgin(dbTrans1);
            tableB2.setSomedata("tableB2");
            tableB2.setReftod(tableD2);
            tableB2.save();
            NDCTableBDO tableB3 = NDCTableBDO.createVirgin(dbTrans1);
            tableB3.setSomedata("tableB3");
            tableB3.setReftod(tableD3);
            tableB3.save();
            NDCTableBDO tableB4 = NDCTableBDO.createVirgin(dbTrans1);
            tableB4.setSomedata("tableB4");
            tableB4.setReftod(tableD4);
            tableB4.save();
            NDCTableBDO tableB5 = NDCTableBDO.createVirgin(dbTrans1);
            tableB5.setSomedata("tableB5");
            tableB5.setReftod(tableD5);
            tableB5.save();
            NDCTableBDO tableB6 = NDCTableBDO.createVirgin(dbTrans1);
            tableB6.setSomedata("tableB6");
            tableB6.setReftod(tableD6);
            tableB6.save();
            if(!autoWrite)
                dbTrans1.write();

            NDCTableADO tableA1 = NDCTableADO.createVirgin(dbTrans1);
            tableA1.setSomedata("tableA1");
            tableA1.setReftob(tableB1);
            tableA1.setReftoc(tableC1);
            tableA1.save();
            NDCTableADO tableA2 = NDCTableADO.createVirgin(dbTrans1);
            tableA2.setSomedata("tableA2");
            tableA2.setReftob(tableB2);
            tableA2.setReftoc(tableC2);
            tableA2.save();
            NDCTableADO tableA3 = NDCTableADO.createVirgin(dbTrans1);
            tableA3.setSomedata("tableA3");
            tableA3.setReftob(tableB3);
            tableA3.setReftoc(tableC3);
            tableA3.save();
            NDCTableADO tableA4 = NDCTableADO.createVirgin(dbTrans1);
            tableA4.setSomedata("tableA4");
            tableA4.setReftob(tableB4);
            tableA4.setReftoc(tableC4);
            tableA4.save();
            NDCTableADO tableA5 = NDCTableADO.createVirgin(dbTrans1);
            tableA5.setSomedata("tableA5");
            tableA5.setReftob(tableB5);
            tableA5.setReftoc(tableC5);
            tableA5.save();
            NDCTableADO tableA6 = NDCTableADO.createVirgin(dbTrans1);
            tableA6.setSomedata("tableA6");
            tableA6.setReftob(tableB6);
            tableA6.setReftoc(tableC6);
            tableA6.save();
            if(!autoWrite)
                dbTrans1.write();
            dbTrans1.commit();
            //dbTrans1.release();
            //dbTrans1 = DODS.getDatabaseManager().createTransaction();

            System.err.println("rows inserted");
            showTables(dbTrans1);

            System.err.print("delete1 --- ");
            tableD1.delete();
            System.err.print("delete2 --- ");
            tableD2.delete();
            System.err.print("delete3 --- ");
            tableD3.delete();
            System.err.print("delete4 --- ");
            tableD4.delete();
            System.err.print("delete5 --- ");
            tableD5.delete();
            System.err.println("delete6 ---");
            tableD6.delete();
            if(!autoWrite)
                dbTrans1.write();

            showTables(dbTrans1);

            System.err.print("unDelete1 --- ");
            tableD1.unDelete();
            System.err.println("newD1:"+tableD1.getHandle());
            System.err.print("unDelete2 --- ");
            tableD2.unDelete();
            System.err.println("newD2:"+tableD2.getHandle());
            if(!autoWrite)
                dbTrans1.write();

            System.err.println("after undelete there are two D's, aren't they?");
            showTables(dbTrans1);

            tableD1.delete();
            tableD2.delete();

            if (null != dbTrans1)
                dbTrans1.commit();
            System.err.println("that's all folks, table are empty now, I hope :) ");
            showTables(dbTrans1);
        }catch (Exception ex){
            System.err.println(ex.toString());
            ex.printStackTrace();
        }
    }
}
