@echo off
rem
rem Converting doml 5.* file into ptl file.
rem
rem  doml2ptl [-help] [doml5*-file] [ptl-file] 
rem
rem  -help - Print usage message and exit.
rem
rem doml5*-file - doml file relese 5.*.
rem ptl-file - desired target ptl file
rem


set USAGE=doml2ptl [-help] [doml5*-file] [ptl-file]

set DODS_HOME=d:\sasaboy\prozonecvs\DODSX\output

set PATH="C:/jdk1.5.0_14\bin";%PATH%
set JAVACMD=java.exe

set DOML2PTLXSL="%DODS_HOME%\build\xsl\doml2ptl.xsl"

:start0
echo %DOML2PTLXSL%
if exist %DOML2PTLXSL% goto start
echo.
echo Unable to find necessary xsl file. Set DOML2PTLXSL in this bat file.
echo.
goto exit

:start
if %1.==. goto error1
if %1==-help goto help
if %1==-* goto error2
if %1==* goto continue1
goto continue1

:error1
echo Error: There is not any arguments: %USAGE%
goto exit

:error2
echo Error: Invalid option: %USAGE%
goto exit

:error3
echo Error: There is not second argument: %USAGE%
goto exit

:error4
echo Error: There are more then two arguments: %USAGE%
goto exit

:help
echo.
echo Usage: %USAGE%
echo.
goto exit

:continue1
if %2.==. goto error3
if %2==-* goto error2
if %2==* goto continue2
goto continue2

:continue2
if %3.==. goto continue
goto error4


:continue
echo Doml to ptl conversion...
%JAVACMD% -cp "%CLASSPATH%" org.apache.xalan.xslt.Process -in %1 -xsl %DOML2PTLXSL% -out %2

:exit